/**
 * @file ulrenderer.h
 * @brief The interface for the <code>ULRenderer</code> class.
 * @author Jeff Ondich
 */

#ifndef ULRENDERER_H
#define ULRENDERER_H

#include "ulstringpool.h"
#include "uldmiterator.h"

/**
 * @class ULRenderer
 * @brief The base class for the ULD rendering system.
 */

class UL_API ULRenderer
{
public:
    ULRenderer();
    ULRenderer( const ULRenderer& renderer );
    virtual ~ULRenderer();

    virtual void clear();
    virtual ULRenderer& operator=( const ULRenderer& renderer );

    virtual ulstring toString( const ULDMIterator& it ) = 0;
};

#endif

