/////////////////////////////////////////////////////////////////////////////
//
//    ulnumbertranslator.h
//
/////////////////////////////////////////////////////////////////////////////

#ifndef ULNUMBERTRANSLATOR_H
#define ULNUMBERTRANSLATOR_H

#include "ulstring.h"

struct SNumTrans
{
    int n;
    const char *s;
};

class UL_API ULNumberTranslator
{
public:
    enum { kULMaxNumberTranslations = 50 };
    static void     numberToText( const ulstring& digits, ulstring& result, ULLanguage lang );

private:
    static void     getNumberWord( int n, const SNumTrans *numberWords, ulstring& word );
	static void		setNumberWord( int n, SNumTrans *numberWords, const char* word );
    static void     englishNumberToText( const ulstring& digits, ulstring& result );
    static void     frenchNumberToText( const ulstring& digits, ulstring& result );
    static void     germanNumberToText( const ulstring& digits, ulstring& result );
    static void     spanishNumberToText( const ulstring& digits, ulstring& result );
    static void     italianNumberToText( const ulstring& digits, ulstring& result );
    static void     portugueseNumberToText( const ulstring& digits, ulstring& result );
    static void     norwegianNumberToText( const ulstring& digits, ulstring& result );
    static void     latinNumberToText( const ulstring& digits, ulstring& result );
    static void     esperantoNumberToText( const ulstring& digits, ulstring& result );
    static void     dutchNumberToText( const ulstring& digits, ulstring& result );
    static void     russianNumberToText( const ulstring& digits, ulstring& result );
    static void     polishNumberToText( const ulstring& digits, ulstring& result );
    static void     chineseNumberToText( const ulstring& digits, ulstring& result );
    static void     klingonNumberToText( const ulstring& digits, ulstring& result );
    static void     turkishNumberToText( const ulstring& digits, ulstring& result );
    static void     haitianNumberToText( const ulstring& digits, ulstring& result );
};

#endif
