
function init()
{
    initWebTool();
}

function getCaseSensitive()
{
    return !$("ULIgnoreCapitalization").checked;
}

function getIgnoreAccents()
{
    return $("ULIgnoreAccents").checked;
}

function getWholeWordsOnly()
{
    return $("ULWholeWordsOnly").checked;
}

function scrollToTermID(termID)
{
    $("ULTerm" + termID).scrollIntoView(true);
    
    // Scroll to make way for the navigation bar.
    if ($("ULDictionarySeeAlso").style.display != "none") {
        window.scrollBy(0, -25);
    }
}

function w(elem) {
    if (window.external) // win
        window.external.OnUserClickedAWord(elem.innerHTML, determineWordLanguage(elem));
    else // mac 
        ULWebToolController.wordClicked(elem); 
}

function didUpdateSeeAlso(html)
{
    var result = $("ULResult");
    var seeAlso = $("ULDictionarySeeAlso");

    if (html != "") {
        seeAlso.style.display = "block";
        seeAlso = replaceHtml(seeAlso, html);
        result.style.marginTop = "25px";
    } else {
        seeAlso.style.display = "none";
        result.style.marginTop = "0";
    }
}

function userDoubleClickedWord(word, target) {
    if (window.external) // win
        window.external.OnUserClickedAWord(word, determineWordLanguage(target));
    else // mac 
        alert("ERROR: This function should only be called in the windows client.");
}

// currently windows client only
function deleteAddition(element)
{
    window.external.OnUserClickedDeleteAddition(element.getAttribute('ULTermID'), 
                                                element.getAttribute('ULDefinitionNumber'));
}

// currently windows client only
function editAddition(element)
{
    window.external.OnUserClickedEditAddition(element.getAttribute('ULTermID'),
                                              element.getAttribute('ULDefinitionNumber'));
}

// override and capture right click if we are in a windows environment
// this code should suppress the right click menu
if (isWindowsV7()) 
{
    function noContextMenu() 
    {
        event.cancelBubble = true;
        event.returnValue = false;
        return false;
    }

    function doRightClick(e)
    {
        if (!e) e = window.event;
        if (!e)
        {
            window.alert("Error: Right click event not present.");
            return;
        }

        if (e.button == 2 || e.button == 3) {

            if (document.body && document.body.createTextRange) {
                // determine what tag we clicked on
                var wordTag;
                if (e.target) wordTag = e.target; // not sure if we need this
                else if (e.srcElement) wordTag = e.srcElement;

                // If what you clicked on is the whole document just return
                if (wordTag.parentNode == document) {
                    return;
                }
                if (isRestricted(wordTag)) {
                    return;
                }

                // If the user has already selected text use that instead of the word they clicked on.
                // This lets them select phrases.
                var range = document.selection.createRange();
                if (range.text == "") {
                    // Create a range and move it to the point we clicked on. Then expand it to the word.
                    range = document.body.createTextRange();
                    range.moveToPoint(e.clientX, e.clientY);
                    range.expand('word');

                    // In klingon, words can start with an apostrophe. range.expand('word') doesn't count them as a word.
                    // So we need to check if there is one there.
                    range.moveStart('character', -1);
                    // if text starts with a whitespace character, move the range back to the old one.
                    if (range.text.match(/^\s\S*/)) {
                        range.moveStart('character', 1);
                    }

                    //highlight the selection
                    range.select();
                }
                
                if (wordTag && range.text != "") {
                    var className = determineWordLanguage(wordTag);
                    //trigger .net right-click-age
                    window.external.OnUserRightClicked(className, range.text);
                }
            }
        
            // suppress further right-click-age
            e.cancelBubble = true;
            e.returnValue = false;
            return false;
        }
    }
    
    //ie is too slow at rendering so we can't have links around every word to help determine what language
    // it is in. This attempts to make a best guess based on the tag structure.
    function determineWordLanguage(wordTag)
    {
        // dW means the word is in the translation language.
        // w means it is in the search language.
        // This follows the convention set by the old word link classes.
        // This function will get some things wrong!
        if (isCollinsOutput(wordTag))
        {
            if (wordTag.className == 'text')
                return 'dW';
            else
                return 'w';
        }
        else
        {
            if (wordTag.className == 'ultext' && wordTag.parentNode.nodeName == 'LI')
                return 'dW';
            else
                return 'w';
        }
    }
    
    function isCollinsOutput(startNode)
    {
        // Starting with startTag, climb the tree to see if there is a parent div with a class of "Collins".
        var currentNode = startNode;
        while (currentNode.parentNode)
        {
            if (currentNode.className == 'Collins')
            {
                return true;
            }
            currentNode = currentNode.parentNode;
        }
        return false;
    }

    function isRestricted(startNode) {
        // Climb the dom and don't show the right click menu if inside a div with the class of ULMessage or an id of ULDictionarySeeAlso
        var currentNode = startNode;
        if (currentNode.tagName == 'BODY' || currentNode.tagName == 'HTML') {
            return true;
        }
        while (currentNode.parentNode) {
            if (currentNode.className == 'ULMessage') {
                return true;
            }
            else if (currentNode.id == 'ULDictionarySeeAlso') {
                return true;
            }
            currentNode = currentNode.parentNode;
        }
        return false;
    }

    document.oncontextmenu = noContextMenu;
    document.onmousedown = doRightClick;
    document.onmouseup = doRightClick;    
}
