////////////////////////////////////////////////////////////////////////////
//
//    ulcompressor.h
//
//  1/13/01 (Jeff Ondich) Started.  Adapted from code published
//      by Mark R. Nelson in Dr. Dobbs' Journal, April 1989.
//
//  1/21/01 (JO) Modified for use with Ultra Lingua Windows.
//
//  7/12/04 (JO) Updated for incorporation into ULAPI 5.0, just
//      a couple days before the last of the LZW patents expires.
//
////////////////////////////////////////////////////////////////////////////

#ifndef ULCOMPRESSOR_H
#define ULCOMPRESSOR_H

#include "zlib.h"
#include "ultypes.h"

class ULCompressor
{
private:
    int         mError;
    z_stream    mCompressionStream;
    z_stream    mExpansionStream;

public:
    static ULCompressor *create();

                ULCompressor();
                ~ULCompressor();

    bool        init();
    bool        isOK();

    uint32      compress( uint8 *source,
                          uint32 sourceLength,
                          uint8 *destination,
                          uint32 destinationLength );

    uint32      expand( uint8 *source,
                        uint32 sourceLength,
                        uint8 *destination,
                        uint32 destinationLength );
};

#endif
