// JS key code constants.
var JSKeyLeftArrow = 63234;
var JSKeyRightArrow = 63235;
var JSKeyUpArrow = 63232;
var JSKeyDownArrow = 63233;
var JSKeyEnter = 3;
var JSKeyReturn = 13;
var JSKeyDelete = 8;
var JSKeyForwardDelete = 63272;
var JSKeySpace = 32;

function $(id)
{
    return document.getElementById(id);
}

function initWebTool()
{
    var e;
    var desktopApp;
    
    if (isWindowsV7()) desktopApp = window.external;
    else desktopApp = ULWebToolController;
        
    e = $("ULWebOperatingSystem");
    if (e) e.value = desktopApp.operatingSystem();

    e = $("ULWebUILanguage");
    if (e) e.value = desktopApp.uiLanguage();

    e = $("ULWebAppVersion");
    if (e) e.value = desktopApp.appVersion();

    e = $("ULWebAppBundleIdentifier");
    if (e) e.value = desktopApp.appBundleIdentifier();

    setMaxLength();
}

function didUpdateResult(html)
{
    var intro = $("ULIntro");
    var expiration = $("ULExpiration");
    var result = $("ULResult");

    if (expiration) {
        expiration.style.display = "none";
    }
    
    // Display the intro text if there's no result.
    if (html == "") {
        if (intro) {
            intro.style.display = "block";
        }
        
        if (result) {
            result.style.display = "none";
            result = replaceHtml(result, html);
        }
    } else {
        if (intro) {
            intro.style.display = "none";
        }
        
        if (result) {
            result.style.display = "block";
            result = replaceHtml(result, html);
        }
    }
}

function willSendIncrementalResults()
{
    var result = $("ULResult");
    result = replaceHtml(result, "");
}

function didUpdateResultIncrementally(html)
{
    var intro = $("ULIntro");
    var expiration = $("ULExpiration");
    var result = $("ULResult");
    
    if (expiration) {
        expiration.style.display = "none";
    }
    
    // Display the intro text if there's no result.
    if (html == "") {
        if (intro) {
            intro.style.display = "block";
        }
        
        if (result) {
            result.style.display = "none";
            result.innerHTML += html;
        }
    } else {
        if (intro) {
            intro.style.display = "none";
        }
        
        if (result) {
            result.style.display = "block";
            result.innerHTML += html;
        }
    }
}

function displayExpirationMessage(html)
{
    var intro = $("ULIntro");
    var expiration = $("ULExpiration");
    var result = $("ULResult");
    
    if (intro) {
        intro.style.display = "none";
    }
    
    if (expiration) {
        expiration.style.display = "block";
        expiration = replaceHtml(expiration, html);
    }
    
    if (result) {
        result.style.display = "none";
    }
}

// Adapted from: http://www.quirksmode.org/dom/maxlength.html
function setMaxLength()
{
    var x = document.getElementsByTagName('textarea');
    var counter = document.createElement('div');
    counter.className = 'counter';
    for (var i = 0; i < x.length; i++) {
        if (x[i].getAttribute('maxlength')) {
            var counterClone = counter.cloneNode(true);
            x[i].onkeydown = x[i].onfocus = x[i].onblur = function () {
                myThis = this;
                
                // Ensure that pastes don't get past our maximum length.
                setTimeout('checkMaxLength(myThis)', 100);
                setTimeout('checkMaxLength(myThis)', 500);
            };
        }
    }
}

// Adapted from: http://www.quirksmode.org/dom/maxlength.html
function checkMaxLength(e) {
    var maxLength = e.getAttribute('maxlength');
    var currentLength = e.value.length;
    if (currentLength > maxLength) {
        e.value = e.value.substr(0, maxLength);
    }
}

// http://www.quirksmode.org/js/findpos.html
function findPos(obj) {
    var curleft = curtop = 0;
    if (obj.offsetParent) {
        do {
            curleft += obj.offsetLeft;
            curtop += obj.offsetTop;
        } while (obj = obj.offsetParent);
    }
    return [curleft,curtop];
}

function increaseFontSize()
{
    var e = document.body;
    increaseFontSize.currentFontSize += 1;
    e.style.fontSize = increaseFontSize.currentFontSize + "px";
}
increaseFontSize.currentFontSize = 10;

function getFontSize() { return increaseFontSize.currentFontSize; }
function setFontSize(size)
{
    increaseFontSize.currentFontSize = size;
    var e = document.body;
    e.style.fontSize = size + "px";
}

function decreaseFontSize()
{
    var e = document.body;
    increaseFontSize.currentFontSize -= 1;
    if (increaseFontSize.currentFontSize < 1) increaseFontSize.currentFontSize = 1;
    e.style.fontSize = increaseFontSize.currentFontSize + "px";
}

function isWindowsV7()
{
    // window.external should only be defined if we are 
    // in a windows/IE environment.
    return window.external;
}

// Source: http://blog.stevenlevithan.com/archives/faster-than-innerhtml
function replaceHtml(el, html) {
	var oldEl = typeof el === "string" ? document.getElementById(el) : el;
	/*@cc_on // Pure innerHTML is slightly faster in IE
     oldEl.innerHTML = html;
     return oldEl;
     @*/
	var newEl = oldEl.cloneNode(false);
	newEl.innerHTML = html;
	oldEl.parentNode.replaceChild(newEl, oldEl);
	/* Since we just removed the old element from the DOM, return a reference
     to the new element, which can be used to restore variable references. */
	return newEl;
};

function setBackground(uri) {
    document.body.background = uri;
}

function sayhi(message)
{
    alert('Message: ' + message);
}

