var selectedMatch = -1;

function init()
{
    initWebTool();
    
    if(window.addEventListener) // mac only
        window.addEventListener("keypress", keyPressed, false);
}

function keyPressed(e)
{
    switch (e.keyCode) {
        case JSKeyEnter:
        case JSKeyReturn:
        case JSKeySpace:
            chooseSelectedResult();
            e.preventDefault();
            break;
            
        case JSKeyUpArrow:
            moveUp();
            e.preventDefault();
            break;
            
        case JSKeyDownArrow:
            moveDown();
            e.preventDefault();
            break;
    }
}

function chooseSelectedResult()
{
    ULWebToolController.matchClicked(selectedMatch);
}

function moveUp()
{
    selectMatch(selectedMatch - 1);
}

function moveDown()
{
    selectMatch(selectedMatch + 1);
}

function clickMatch(match)
{
    selectedMatch = match;

    if (isWindowsV7())
    {
        var matchedElement = $("ULMatch" + selectedMatch);
        window.external.OnUserClickedInfinitive(matchedElement.innerHTML);
    }
    else { ULWebToolController.matchClicked(match); }
}

function selectMatch(match)
{
    var oldMatch = $("ULMatch" + selectedMatch);
    
    var newMatch = $("ULMatch" + match);
    if (newMatch) {
        newMatch.className = "ULSelected";
        if (oldMatch) {
            oldMatch.className = "";
        }

        selectedMatch = match;
        if (newMatch.scrollIntoViewIfNeeded) {
            newMatch.scrollIntoViewIfNeeded();
        } else {
            newMatch.scrollIntoView(false);
        }
    }
}

// this code should suppress the right click menu
if (isWindowsV7()) {
    function noContextMenu() {
        event.cancelBubble = true;
        event.returnValue = false;
        return false;
    }

    document.oncontextmenu = noContextMenu;
}

